# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2010 <Andrew C Sellers> <andrew@andrewcsellers.com>
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#    http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
### END LICENSE

#TODO standardize variable names
#TODO split up functions
import gtk

class AreaSelector(gtk.Window):
	def __init__(self):
		gtk.Window.__init__(self)
		
		#make a pretty window
		self.set_app_paintable(True)
		self.fullscreen()
		self.show_all()
		
		#get a pretty picture
		desktop = gtk.gdk.get_default_root_window()
		(self.width,self.height) = desktop.get_size()
		self.screenshot = desktop.get_image(0,0,self.width,self.height)
		#yay we now screenshotted the desktop

		#lolwut, i think we need some signals
		self.connect('button_press_event',self.i_pressed_it)
		self.connect('button-release-event',self.i_stopped_pressing_it)
		self.connect('motion-notify-event',self.i_moved_it)
		self.connect('expose-event',self.i_see_you)
		
		#init some values
		self.x = -1
		self.y = -1
		self.tx = 0
		self.ty = 0
		self.done=False
		self.cb=False
		#i'm not being realized, maybe this works here
		low_window = self.window
		low_window.set_events(low_window.get_events() | gtk.gdk.BUTTON_PRESS_MASK | gtk.gdk.BUTTON_RELEASE_MASK | gtk.gdk.POINTER_MOTION_MASK)
		cursor = gtk.gdk.Cursor(gtk.gdk.SIZING)
		low_window.set_cursor(cursor)
		low_window.set_back_pixmap(None,0)
		
	def i_pressed_it(self,widget,data=None):
		#the left button thank you berry much
		self.x = int(data.x)
		self.y = int(data.y)
		self.tx = self.x+1
		self.ty=self.y+1
	def i_stopped_pressing_it(self,widget,data=None):
		self.tx = max(int(data.x),self.x)
		self.ty = max(int(data.y),self.y)
		self.x = min(int(data.x),self.x)
		self.y = min(int(data.y),self.y)
		self.destroy()
		self.done=True
		if self.cb:
			self.cb()
	def i_moved_it(self,widget,data=None):
		self.queue_draw()
		if self.x >=0:
			tx = int(data.x)
			ty =  int(data.y)
			self.queue_draw_area(min(self.x,tx),min(self.y,ty),abs(self.x-tx),abs(self.y-ty))
		sx=self.x
		sy=self.y
		try:
			self.x = min(sx,tx)
		except:
			tx=sx+1
			ty=sx+1
			self.x=min(sx,tx)
		self.y=min(sy,ty)
		self.tx = max(sx,tx)
		self.ty=max(sy,ty)
		return True#we want to do this again
		
	
	def i_see_you(self,widget,data=None):
		dashing = [2.0,4.0] #let's make a dashed line, why not?
		self.context = widget.window.cairo_create()
		self.context.rectangle(data.area.x,data.area.y,data.area.width,data.area.height)
		self.context.clip()
		self.window.draw_image(self.style.black_gc, self.screenshot, 0,0, 0,0, self.width,self.height)
		self.context.save()
		self.context.set_source_rgb(.5,0,1)
		self.context.set_dash(dashing)
		self.context.rectangle(self.x,self.y,self.tx-self.x,self.ty-self.y)
		self.context.rectangle(self.x+0.5,self.y+0.5,self.tx-self.x-1,self.ty-self.y-1)
		self.context.stroke()
		self.context.restore()
		return False
		
	def get_area(self):
		if not self.done:
			return False
		return [self.x,self.y,self.tx,self.ty]
	def set_callback(self,cb):
		self.cb = cb
