# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2010 <Andrew C Sellers> <andrew@andrewcsellers.com>
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#    http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
### END LICENSE

class EncoderOptions:
    supported_encoders = ['x264enc','theoraenc','vp8enc']
    supported_levels = {'x264enc':[0,1,2,3,4],'theoraenc':[],'vp8enc':[]}
    optimization = {
    'x264enc':{
        4:'speed-preset=ultrafast',
        3:'speed-preset=superfast',
        2:'speed-preset=superfast bitrate=4096',
        1:'speed-preset=veryfast',
        0:'speed-preset=veryfast bitrate=4096'
    },
    'theoraenc':{'fallback':'quality=36'},
    'vp8enc':{'fallback':'speed=2'}
    }
    
    
    def get_optimization(self,encoder,optimization_level):
        optimization = ''
        if encoder in self.supported_encoders:
            if optimization_level in self.supported_levels[encoder]:
                optimization = self.optimization[encoder][optimization_level]
            else:
                optimization = self.optimization[encoder]['fallback']
        return optimization
