# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2010 <Andrew C Sellers> <andrew@andrewcsellers.com>
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#    http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
### END LICENSE
import gst
class PresetManager:
    def get_preset_list(self):
        ret = dict()
        for i in presets:
            ve = gst.element_factory_find(presets[i]['video_encoder'])
            ae = gst.element_factory_find(presets[i]['audio_encoder'])
            if not ae == None and not ve == None:
                ret[i]=presets[i]['name']
        return ret
    def load_preset(self,preset_num):
        if preset_num in presets.keys():
            return presets[preset_num]
        
presets = {
    1:{'name':'Ogg Media', 'mux':'ogg', 'video_encoder':'theoraenc', 'audio_encoder':'vorbisenc','mime':'video/x-theora+ogg',
        'desc':
'''Ogg Media will output a Theora video
with Vorbis Audio, free to use but not
the best in picture quality or cpu speed.'''
            },
    2:{'name':'WebM Media', 'mux':'webm', 'video_encoder':'vp8enc', 'audio_encoder':'vorbisenc','mime':'video/webm',
        'desc':
'''WebM is Google's HTML5 video format.'''
            },
    3:{'name':'Avi - XVid', 'mux':'avi', 'video_encoder':'xvidenc', 'audio_encoder':'lamemp3enc','mime':'video/x-msvideo',
        'desc':
'''Avi - Xvid will output a Windows Avi file
with Xvid format video and mp3 format
sound, this is very common.'''
            },
    4:{'name':'Matroska - XVid', 'mux':'matroska', 'video_encoder':'xvidenc', 'audio_encoder':'vorbisenc','mime':'video/x-matroska',
        'desc':
'''Matroska - Xvid will output xvid video and
vorbis sound in a matroska container, it's
oss based and shouldn't have any patent 
issues.'''
            },
    5:{'name':'Matroska - h264', 'mux':'matroska', 'video_encoder':'x264enc', 'audio_encoder':'vorbisenc','mime':'video/x-matroska',
        'desc':
'''Matroska - h264 uses h264 for video,
which is a patent encumbered format, but
the encoder is quite fast in my tests, audio
is vorbis encoded.'''
            },
    6:{'name':'Matroska - Huffman', 'mux':'matroska', 'video_encoder':'ffenc_huffyuv', 'audio_encoder':'vorbisenc','mime':'video/x-matroska',
        'desc':
'''Matroska - huffman is fast, and gives
out amazing quality. It can output large
files though, so watch out. Also it isn't
super common to find players.'''
            },
    7:{'name':'Flash - 10.X', 'mux':'flv', 'video_encoder':'x264enc', 'audio_encoder':'lamemp3enc','mime':'video/x-flv',
        'desc':
'''Flash 10.X will output a video in a 
flv container that should be compatible
with most flash players. Uses h264 for 
video and mp3 for audio. Yes, both of 
these codecs are patent-encumbered.'''
            }

    }
    
