# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2010 <Andrew C Sellers> <andrew@andrewcsellers.com>
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#    http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
### END LICENSE

import gtk
from tibesti import Options
from tibesti.helpers import get_builder
import datetime
import gettext
from gettext import gettext as _
gettext.textdomain('tibesti')

class SaveDialog(gtk.Dialog):
    __gtype_name__ = "SaveDialog"

    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated SaveDialog object.
        """
        builder = get_builder('SaveDialog')
        new_object = builder.get_object('save_dialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a SaveDialog object with it in order to
        finish initializing the start of the new SaveDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.builder.connect_signals(self)
        self.options=Options.OptionsStore()
        
        self.builder.get_object("file_selector").set_current_folder(self.options.get_save_dir())
        filefilter = self.builder.get_object("filter")
        filefilter.add_mime_type(self.options.get_mime_type())
        
    def ok(self, widget, data=None):
        """The user has elected to save the changes.

        Called before the dialog returns gtk.RESONSE_OK from run().
        """
        pass
    def set_name(self,ending):
        timer = datetime.datetime.now().isoformat()
        self.builder.get_object("file_selector").set_current_name("Screencast-%s%s"%(timer,ending))

    def set_full_name(self,name):
        self.builder.get_object("file_selector").set_current_name(name)

    def cancel(self, widget, data=None):
        """The user has elected cancel changes.

        Called before the dialog returns gtk.RESPONSE_CANCEL for run()
        """
        pass
        
    def get_save_file(self):
        return self.builder.get_object('file_selector').get_filename()

	def set_start_folder(self,folder_uri):
		self.builder.get_object('file_selector').set_current_folder_uri('file://'+folder_uri)
		
	def activate(self):
		self.builder.get_object('file_selector').show()
		self.builder.get_object('temp_label').destroy()
        
    def check_overwrite(self,*data):
        print data
        print "co"
        
        
		
if __name__ == "__main__":
    dialog = SaveDialog()
    dialog.show()
    gtk.main()
